<?php

    /* AXISAPI NAMESPACE */
    namespace axisapi;

    function call( $in_array  ) {
        /* 
            expects command (or endpoint), returntype ('xml' or 'json'), and optionally p1 through p5 
        */
        
        global $axisapi_server, $axisapi_key;

        // BAIL IF WE DON'T AT LEAST HAVE A COMMAND OR ENDPOINT
        if ( isset($in_array['command']) == false || $in_array['command'] == "" ) {
            $in_array['command'] = str_replace( "/", "__", $in_array['endpoint'] );
            if ( $in_array['command'] == "" ) {
                return "COMMAND INVALID";   
            }
        }
        
        // HTTP POST
        $axisapi_server	= "{$axisapi_server}lms/api.php";
        $params = array(
            'auth'      => $axisapi_key,
            'command'   => $in_array['command']
        );
        
        // ADD PARAMS
        if ( isset($in_array['p1']) == true ) { $params['p1'] = $in_array['p1']; }
        if ( isset($in_array['p2']) == true ) { $params['p2'] = $in_array['p2']; }
        if ( isset($in_array['p3']) == true ) { $params['p3'] = $in_array['p3']; }
        if ( isset($in_array['p4']) == true ) { $params['p4'] = $in_array['p4']; }
        if ( isset($in_array['p5']) == true ) { $params['p5'] = $in_array['p5']; }
        
        // DO THE API CALL
        $curlHandle = curl_init( $axisapi_server );
        curl_setopt( $curlHandle, CURLOPT_POSTFIELDS, $params );
        curl_setopt( $curlHandle, CURLOPT_RETURNTRANSFER, true );
        $curlResponse = curl_exec( $curlHandle );
        curl_close( $curlHandle );
        
        // RETURN IN XML OR JSON
        if ( $in_array['returntype'] == 'xml' ) {
            return $curlResponse;
            
        } else {
            return getJSON( $curlResponse );
            
        }
        
    }

    function getTagData( $in_tag_name, $in_xml_string )  {
        
        // PARSE THE XML-LIKE TAG STRUCURES SOME ENDPOINTS RETURN
        if ( strlen( strstr($in_xml_string, "<{$in_tag_name}>") ) > 0  ) {
            $start = strpos( $in_xml_string, "<{$in_tag_name}>" );
            $start = $start + strlen( "<{$in_tag_name}>" );
            $end = ( strpos( $in_xml_string, "</{$in_tag_name}>" ) ); 
            $num = ( $end - $start );
            $valore = substr( $in_xml_string, $start, $num );
            return $valore;
            
        } else {
            return "";
            
        }
    }

    function getJSON( $in_data, $in_type = 'result-data', $return_as_array = false ) {

        if ( $in_type == 'tagged-data' ) {

            $xml 	= simplexml_load_string( $in_data );
            $i = 0;
            $j = 0;
            $t = 0;

            foreach( $xml->children() as $child ) {
                $schild = (string)$child;

                if ( $i == 0 ) {
                    $results = preg_match_all( '~<([^/][^>]*?)>~', $schild, $tag ); // this gets all tags
                    $i++;
                }

                foreach ( $tag[1] as $item ) {
                    $tmp = getTagData( $item, $child ); 
                    $item_name = $item;
                    if ( hasTaggedData($tmp) == true ) {
                        $datablock[$j][$item_name] = $tmp;
                        
                    } else {
                        $datablock[$j][$item_name] = $tmp;
                        
                    }
                    
                }

                $states[]= $datablock[$j]; 
                $j++;

            }       

            if ( $return_as_array == false ) {
                return json_encode( $states );
                
            } else {
                return $states;
                
            }

        }

        if ( $in_type == 'result-data' ) {

            $xml 	= simplexml_load_string( $in_data );

            foreach( $xml->children() as $child ) {
                $schild = (string)$child;
                if ( $schild != "" ) {
                    if ( hasTaggedData($schild) == true ) {
                        $states[] = array( $child->getName() => getJSON("<?xml version=\"1.0\"?><api_result><result><![CDATA[{$child}]]></result></api_result>", 'tagged-data') );
                        
                    } else {
                        $states[]= array($child->getName() => $schild ); 
                        
                    }
                }
            }       
            return json_encode( $states );

        }

    }

    function hasTaggedData( $in_string ) {
        
        $results = preg_match_all( '~<([^/][^>]*?)>~', $in_string ); // this gets all tags
        if ( $results > 0 ) { return true; } else { return false; }

    }

    function getTagNames( $in_string ) {
        
        $results = preg_match_all( '~<([^/][^>]*?)>~', $in_string, $tags ); // this gets all tags
        return $tags[1];    // 1 array holds tags names without <>
        
    }
    
?>